<?PHP
/*
 * $Id: SPAF.php,v 1.4 2004/03/17 19:08:10 martin Exp $
 */

require 'smarty/Smarty.class.php';
require 'SPAFSession.php';
require 'SPAFError.php';

$SPAFAuthz ? require $SPAFAuthz : require 'SPAFAuthz.php';

class SPAF
{
    var $CONFDIR,$DIR,$FILE,$HOMEDIR,$RTIME,$SESSION,$PARAMS,
        $PPARAMS,$TPLDIR,$error,$_include,$output,$tpl;

    function SPAF($chld='',$params='') {
        global $HOMEDIR, $CONFDIR, $TPLDIR, $DEBUG;

        $this->HOMEDIR = $HOMEDIR;
        $this->CONFDIR = $CONFDIR = $HOMEDIR . '/configs';

        //        $this->TPLDIR = $TPLDIR = $HOMEDIR . '/templates';    
        $TPLDIR = $HOMEDIR . '/templates';    
        $this->TPLDIR = $TPLDIR;

        if (is_object($chld)) {
            $this = &$chld;
        }

        $this->_include = TRUE;
        $this->DIR  = $this->DIR();
        $this->FILE = $this->FILE();


        $this->SPAFError   = new SPAFError($CONFDIR.'/error.msg');
        $this->SPAFMessage = new SPAFMessage($CONFDIR.'/messages.msg');

        $this->tpl = new Smarty;
        $this->tpl->compile_check = true;
        //        $this->tpl->debugging = true;

        $this->tpl->template_dir = $TPLDIR;
        $this->tpl->compile_dir  = $HOMEDIR . '/templates_c';
        $this->tpl->config_dir   = $CONFIGDIR;

        $this->RTIME   = time(); // time of the request

        $params['timeout']
            ? $this->SESSION = new SPAFSession($params['timeout'])
            : $this->SESSION = new SPAFSession(1800);

        $this->PARAMS  = $this->SESSION->fetchParams();
        $this->PPARAMS = $this->SESSION->fetchPParams();

        // set <C>urrent <A>ction
        if($_POST['CA']) {
            $this->CA = $_POST['CA'];
        }
        elseif($_GET['CA']) {
            $this->CA = $_GET['CA'];
        }
        elseif(strlen($_SERVER['PATH_INFO']) > 1) {
            // if script is called: script.php/custom_action
            $this->CA = substr(strrchr($_SERVER['PATH_INFO'],'/'), 1);
        }
        else {
            // We called directly from a script.
            $this->_include = FALSE;
            // set to the basename of the script without .php
            $this->CA = substr($this->FILE,0,strrpos($this->FILE,'.'));
        }

        // set <C>urrent <P>age
        if($_POST['CP']) {
            $this->CP = $_POST['CP'];
        }
        elseif($_GET['CP']) {
            $this->CP = $_GET['CP'];
        }
        else {
            $this->CP = $this->CA;
        }
        $this->PARAMS['RTIME'] = $this->RTIME;

        // Populate current object with parameters where POST
        // overwrite GET.  This will probably overwrite same of the
        // session vars set above
        foreach($_GET  as $var => $value) { $this->PARAMS[$var] = $value; }
        foreach($_POST as $var => $value) { $this->PARAMS[$var] = $value; }
        $this->PARAMS['SID'] = $_REQUEST['PHPSESSID'];
        $this->PARAMS['FILE'] = $this->FILE;
        $this->PARAMS['DIR'] = $this->DIR;

    }

    // run application
    function run() {
        $this->PPARAMS['authz'] = new SPAFAuthz();

        /**
         * Process model
         */

        // process before current action
        if (method_exists($this,'preCA')) {
            $this->preCA();
        }

        // call processor (model functionality) when no error
        $this->setError($this->PPARAMS['authz']->check($this->CA,
                                                       $this->getAccess()));
        if (! $this->error) {
            if (method_exists($this,$this->CA)) {
                $this->{$this->CA}();
            }
            else {
                // If we include the script which has called us, we
                // will get a infinite loop. The script will have done
                // the model processing self.
                if($this->_include && file_exists($file)) {
                    $file = dirname($_SERVER['SCRIPT_FILENAME'])
                        .'/'.$this->CA.'.php';
                    include($file);
                }
            }
        }

        // process before fetch current (response) page The preCP
        // method must return html code of the page to display
        // (e.g. the html headers).
        if (method_exists($this,"preCP")) {
            $this->output .= $this->preCP();
        }

        $this->PARAMS['CP'] = $this->CP;

        // populate params in template
        foreach($this->PARAMS as $param => $value) {
            $this->tpl->assign($param,$value);
        }

        // populate pparams in template, this will overwrite
        // eventually some params
        foreach($this->PPARAMS as $param => $value) {
            $this->tpl->assign($param,$value);
        }
        // debug current params and pparams
        if ($DEBUG >= 5) {
            foreach($this->PARAMS as $param => $value) {
                error_log("PARAMS : $param => $value");
            }
            foreach($this->PPARAMS as $param => $value) {
                error_log("PPARAMS : $param => $value");
            }
        }

        /**
         **
         ** create response page
         **
         **/
        $this->setError($this->PPARAMS['authz']->check($this->CP,
                                                       $this->getAccess()));
        if (! $this->error) {
            $tpl = $this->tpl->template_dir .'/'. $this->CP . '.tpl';

            if(file_exists($tpl)) {
                $this->output .= $this->tpl->fetch($tpl);
            }
            elseif(file_exists($this->DIR . '/error.tpl')) {
                $this->output .= $this->tpl->fetch($this->tpl->template_dir .
                                                   '/error.tpl');
            }
            else {
                error_log("Page $this->CP not found.\n");
                $this->output .= $this->errorPage();
            }
        }
        else {
            $this->pageError();
        }

        // If a postCP() method is defined, it must return html code of
        // the page to display (e.g. the html footers).
        if (method_exists($this,"postCP")) {
            $this->output .= $this->postCP();
        }

        echo $this->output;

        $this->PPARAMS['LA'] = $this->CA;
        $this->PPARAMS['LP'] = $this->CP;
        // store parameters to session
        $this->SESSION->storeParams($this->PARAMS);
        $this->SESSION->storePParams($this->PPARAMS);

        return $this;
    }


    /**
     * returns the access level of the current reqest.
     */
    function getAccess() {
        $ret = $this->getPParam('ACCESS');
        if ($ret) {
            return $ret;
        }
        return 0;
    }

    /**
     * Sets the access level in SESSION and in template {$ACCESS}
     */
    function setAccess($level) {
        $this->setPParam('ACCESS',$level);
    }

    // sets the name
    function setName($name) {
        $this->PPARAMS['NAME'] = $name;
    }

    // fetch value of param
    function getParam($param) {
        return $this->PARAMS[$param];
    }

    // set param
    function setParam($param,$value) {
        return $this->PARAMS[$param] = $value;
    }


    // set params
    function setParams($p_ary) {
        foreach($p_ary as $param => $value) {
            $this->PARAMS[$param] = $value;
        }
        return $this->PARAMS;
    }

    // fetch value of pparam
    function getPParam($param) {
        return $this->PPARAMS[$param];
    }

    // set pparam
    function setPParam($param,$value) {
        return $this->PPARAMS[$param] = $value;
    }


    // set pparams
    function setPParams($p_ary) {
        foreach($p_ary as $param => $value) {
            $this->PPARAMS[$param] = $value;
        }
        return $this->PPARAMS;
    }

    // set CA
    function setCA($value) {
        $this->PARAMS[$CA] = $value;
        $this->CA = $value;
    }

    // set CP
    function setCP($value) {
        $this->PARAMS[$CP] = $value;
        $this->CP = $value;
    }


    // 
    function destroySession() {
        $this->SESSION->destroySession();
    }


    /**
     * sets error and errorMSG
     *
     * setError if no other error is currently set, this method will
     * set the template variables {'errroMSG'} and {'MESSAGE'} to the
     * line assigned to $errorNumber.
     *
     * It returns the current error number.
     *
     */
    function setError($errorNumber) {
        if ($errorNumber && ($this->error == 0)) {
            $this->error = $errorNumber;
            $msg = $this->SPAFError->errorMSG($errorNumber);
            $this->tpl->assign('errorNUM',$errorNumber);
            $this->tpl->assign('errorMSG',$msg);
        }
        return $this->error;
    }


    /**
     * Sets tpl:MESSAGE param at the template and returns the message.
     * If $param is given, tpl:$param will be set to the message
     * $number.
     */
    function setMessage($number,$param='') {
        $msg = $this->SPAFMessage->fetchMSG($number);
        $param ? NULL : $param = 'MESSAGE';
        $this->tpl->assign($param,$msg);
        return $msg;
    }


    // return the directory of the elemetal script
    function DIR() {
        return dirname($_SERVER['SCRIPT_FILENAME']);
    }

    // return the filename of the elemetal script
    function FILE() {
        return basename($_SERVER['SCRIPT_FILENAME']);
    }

    // remove parameter from session
    function removeParam($param) {
        unset($this->PARAMS[$param]);
        $this->SESSION->removeParam($param);
    }
    
    // send error message
    function errorPage() {
        header ("HTTP/1.0 404 Not Found");
        return "Page \"$this->CP\" cannot be found.\n";
    }

    /**
     * pageError will called as the current display CA when
     * $this->error is set.
     *
     * This method can be overwritten by the custom application. If
     * you overwrite this you you must append your content to
     * $this->output.
     *
     */
    function pageError() {
        header ("HTTP/1.0 403 Forbidden");
        $this->output .= "Access to  \"$this->CP\" is  not allowed.<br>\n";
    }


    /**
     * According to the name of the following methods, return the
     * attribute value of the object.
     */
    function HOMEDIR() { return $this->HOMEDIR; }
    function CONFDIR() { return $this->CONFDIR; }
    function TPLDIR()  { return $this->TPLDIR; }

}

/**
 * Print message and die. If defined $errorLog, write this message to
 * error log
 */
function dieError($msg,$errorLog = '') {
    if ($errorLog) {
        error_log($errorLog);
    }
    die($msg);
}

/**
 * Log message to error log.
 */
function warnError($errorLog) {
    error_log($errorLog);
}

?>
