<?PHP
/**
 * $Id: SPAFSession.php,v 1.3 2004/03/17 19:08:10 martin Exp $
 */

class SPAFSession {
    var $NAME,$access;

    function SPAFSession($session_to=1800,$path='/SPAF') {
        session_set_cookie_params($session_time,$path);
        //        session_name();
        session_start();
        if ($_SESSION['RTIME'] && 
            (time() - $_SESSION['RTIME'] > $session_to)) {
            $this->destroySession();
        }
        $this->NAME  = $_SESSION['NAME'];
        $_SESSION['access']
            ? $this->access = $_SESSION['access']
            : $this->access = 0;
    }


    function destroySession() {
        session_unset();
        $_SESSION = array(); 
        unset($_SESSION);
        session_destroy();
        return $this;
    }

    function fetchParam ($param) {
        return $_SESSION['PARAM'][$param];
    }

    function fetchPParam ($param) {
        return $_SESSION['PPARAM'][$param];
    }

    function fetchParams() {
        return $_SESSION['PARAMS'];
    }

    function fetchPParams() {
        return $_SESSION['PPARAMS'];
    }

    // store one parmeter in session
    function storeParam($var,$value) {
        $_SESSION['PARAMS'][$var] = $value;
        return $this;
    }

    // store one parmeter in session
    function storePParam($var,$value) {
        $_SESSION['PPARAMS'][$var] = $value;
        return $this;
    }

    /**
     * Store parameter variables to session if they begin with a '_'.
     */
    function storeParams($params) {
        foreach($params as $var => $value) {
            $pos = strpos($var,'_');
            if (strpos($var,'_') === 0) {
                $_SESSION['PARAMS'][$var] = $value;
            }
        }
        return $this;
    }

    /**
     * PParams will always be stored in session.
     */
    function storePParams($params) {
        foreach($params as $var => $value) {
            $_SESSION['PPARAMS'][$var] = $value;
        }
        return $this;
    }

    function removeParam($param) {
        unset($_SESSION['PARAMS'][$param]);
    }

    function removePParam($param) {
        unset($_SESSION['PPARAMS'][$param]);
    }



}

?>
